<?php
/*
Plugin Name: Download Music
Plugin URI: http://seanhagen.ca/DownloadMusic/
Description: A plugin that lets WordPress users make media files avaliable to download as a zip file.
Author: Sean Hagen
Version: 0.1
Author URI: http://seanhagen.ca/
Generated At: www.wp-fun.co.uk;


Copyright 2008  Sean Hagen  (email : sean.hagen+downloadmusic@gmail.com)

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA


Notice:

The part of the script to create the zip file was taken from 
http://www.phpit.net/article/creating-zip-tar-archives-dynamically-php/

Very helpful.

Changed/copied/modified what I needed to get this to work.


*/

if (!class_exists('DownloadMusic')) {
    class DownloadMusic	{
		/**
		* @var string   The name the options are saved under in the database.
		*/
		var $adminOptionsName = "DownloadMusic_options";
		
		
		/**
		* @var string   The name of the database table used by the plugin
		*/	
		var $db_table_name = 'mediaInfo';

		
		/**
		* PHP 4 Compatible Constructor
		*/
		function DownloadMusic(){$this->__construct();}
		
		/**
		* PHP 5 Constructor
		*/		
		function __construct(){
			global $wpdb;

			if ( isset( $_POST['serve'] ) && $_POST['serve'] == 'css' ) {
			  header('Content-type: text/css');
			  echo '
			
			h1 {
			color: pink;
			border:1px dotted green;
			}
			
			h2 {
			color: red;
			border:1px dotted blue;
			}
			
			}
			';
			  //stop the rest of the content being served		
			  exit;
			} else if ( isset($_POST['processZip']) && $_POST['processZip'] == 'true' ) {
			  //TODO: think about moving this into a seperate file to make the main file more legible.
                          require_once("PEAR.php");
                          require_once("Zip.php");
			  require_once("forceDownload.php");
			  global $wpdb;
			  $query = "select guid from ".$wpdb->prefix."posts where ";
			  $songs = $_POST['songs'];

			  for ( $i=0; $i<sizeof($songs); $i++) {
			    $query .= "post_name='".$songs[$i]."'";
			    if ( $i!=sizeof($songs)-1  ) {
			      $query .= " or ";
			    }
			  }

			  $rez = $wpdb->get_results($query,'ARRAY_N');

			  $url = preg_replace("/\//","\/",get_bloginfo('url'));

			  $directory = "";
			  if ( isset($_SERVER['PHPRC'] ) ) {
			    $directory = $_SERVER['PHPRC']."/";
			  } else {
			    $directory = $_SERVER["DOCUMENT_ROOT"].$_SERVER["REQUEST_URI"];
			    $directory = preg_replace("/\/\//","/",$directory);
			  }

			  //the directory to create the zip file in
			  //we'll use the Wordpress Upload folder, just for fun.
			  $temporary = $directory."wp-content/uploads/";

			  $date = date("_F_d_Y_h_i_s");

			  if (is_writable($temporary) == false) {
			    die ("Temporary directory $temporary isn't writable");
			  }
			  
			  //create temporary folder for the zip file
			  //first make sure that it doesn't exist.
			  $dir = tempnam($temporary, $date);
			  @unlink($dir);
			  @rmdir($dir);
			  mkdir($dir);
			  $dir .= '/';

			  $list = array();
			  for ( $i=0; $i<sizeof($rez); $i++) {
                            $rez[$i][0] = $directory.preg_replace("/".$url."\//","",$rez[$i][0]);
                            $list[] = $rez[$i][0];
                          }

			  // Copy files & directories so relative paths still work
			  for ($i=0; $i<sizeof($list); $i++) {
			    if (is_file($list[$i])) {
			      // Copy file
			      copy ($list[$i], $dir.basename($list[$i]));
			      $list[$i] = basename($list[$i]);
			    } else {
			      // Invalid file, just ignore
			      continue;
			    }
			  }

			  //move to tempdir, so that's where we are when the zip is created.
			  chdir($dir);

			  $zipname = get_bloginfo('url');
			  $zipname = preg_replace("/http\:\/\//","",$zipname);
			  $zipname = preg_replace("/\./","_",$zipname);
			  $zipname = preg_replace("/\//","_",$zipname);

			  $zipname .= $date.".zip";

			  $zipfile = new Archive_Zip($zipname);
			  $zipfile->create($list);
			  force_download($zipname,$zipname,'application/zip');
			  
			  chdir("..");
			  $this->rm_recurse($dir);
			  exit;
			}
		
			//not working just yet.
			//add_action("admin_menu", array(&$this,"add_admin_pages"));

  			add_filter("the_content", array(&$this,"modifyAttachmentPageBeforeDisplay"));
			register_activation_hook(__FILE__,array(&$this,"install_on_activation"));
			add_action("wp_head", array(&$this,"add_css"));

			$this->adminOptions = $this->getAdminOptions();
			$this->db_table_name = $wpdb->prefix . "download_music";
		}
		
		function rm_recurse($file) {
		    if (is_dir($file) && !is_link($file)) {
		            foreach(glob($file.'/*') as $sf) {
			       if ( !$this->rm_recurse($sf) ) {
			         error_log("Failed to remove $sf\n");
				 return false;
            		       }
        	            }
                            return rmdir($file);
                    } else {
                            return unlink($file);
                    }
                }
		/**
		 *
		 */
		function modifyAttachmentPageBeforeDisplay($content = ''){
		  global $id, $post_type,$wpdb;
		  $rez = $wpdb->get_row("select post_type,guid,post_title from ".$wpdb->prefix."posts where id=".$id);

		  $uri = $_SERVER['REQUEST_URI'];
		  $uri = preg_replace("/\?.*/","",$uri);

		  if ( $rez->post_type == "attachment" ) {
		    $content = preg_replace("/<p class=\"attachment\"><a href.*<\/a><\/p>/","",$content);
		  } 

		  //TODO: fix so that the page doesn't have to be named 'Downloads'
		  if ( $rez->post_type == "page" && preg_match("/Downloads/",$rez->post_title) ){
		    $downloads = $wpdb->get_results("select ID,post_content, post_title, post_name,post_mime_type, guid from ".$wpdb->prefix."posts where post_type='attachment' and post_mime_type like 'audio%'");
		    $content .= "\n\n<p><span style=\"font-size: 10pt; font-style: italic;\">Tip: Use the checkboxes to download multiple songs in a single zip file!</span></p>\n";
		    $content .= "<form action=\"".$uri."\" method=\"post\" name=\"downloadSongs\" style=\"text-align: left;\">\n";
		    foreach ( $downloads as $d ) {
		      $content .= "\n\n<p><input type=\"checkbox\" name=\"songs[]\" value=\"".$d->post_name."\" ><a href=\"".$uri."?attachment_id=".$d->ID."\" >".$d->post_title."</a></input>\n";
		      $content .= "<br /> <span style=\"left: 20px; position: relative;\">".$d->post_content."</p>";
                      //uncomment this line to let people download single songs directly.
                      //$content .= "<a href=\"".wp_get_attachment_url($d->ID)."\">Download</a></span></p>\n";
		    }
		    $content .= "\n\n<br />";
		    $content .= "\n<input type=\"submit\" name=\"submit\" value=\"Download All Selected\" />\n";
		    $content .= '<input type="hidden" name="processZip" value="true" />';
		    $content .= "\n</form>\n";

		  }
		  $content .= get_option('downlods_page');
		  return $content;
		}
		
		/**
		* Retrieves the options from the database.
		* @return array
		*/
		function getAdminOptions() {
		  $adminOptions = array("download_page" => "Download");
		  $savedOptions = get_option($this->adminOptionsName);
		  if (!empty($savedOptions)) {
		    foreach ($savedOptions as $key => $option) {
		      $adminOptions[$key] = $option;
		    }
		  }
		  update_option($this->adminOptionsName, $adminOptions);
		  return $adminOptions;
		}
		
		/**
		* Saves the admin options to the database.
		*/
		function saveAdminOptions(){
		  update_option($this->adminOptionsName, $this->adminOptions);
		}
		
		function add_admin_pages(){
		  add_menu_page('Make Avaliable Configuration', 'MakeAvaliable Configuration', 10, __FILE__, array(&$this,"output_main_admin_page"));
		}
		
		/**
		* Outputs the HTML for the admin page.
		* TODO: Get the admin page up and working
		*/
		function output_main_admin_page(){
		  $hidden_field = 'new_download_page_title';
		  $data_field = 'download_page_title';
		  $opt_name = 'download_page';

		  $opt_value = get_option($opt_name);

		  if( $_POST[ $hidden_field ] == 'Y' ) {
		    // Read their posted value
		    $opt_val = $_POST[ $data_field ];
		    // Save the posted value in the database
		    update_option( $opt_name, $opt_val );
		    // Put an options updated message on the screen
?>
		      <div class="updated"><p><strong>Options Saved</strong></p></div>
		  <?php
			 }
		  ?>
			<div class="wrap">
		           <h2>Make Avaliable</h2>
			   <form name="form1" method="post" action="<?php echo str_replace( '%7E', '~', $_SERVER['REQUEST_URI']); ?>" >
			   <p>Name of page to offer download list on: <input name="<?php print $data_field; ?>" type="text" value="<?php print $opt_value; ?>"/>
			   <input type="hidden" name="<?php print $hidden_field; ?>" value="Y" />
			   <p class="submit">
			   <input type="submit" name="Submit" value="Update Options" />
			   </p>

			</div>
			<?php
		}
		
		
		/**
		* Adds a link to the stylesheet to the header
		*/
		function add_css(){
		  echo '<link rel="stylesheet" href="'.get_bloginfo('wpurl').'/wp-content/plugins/DownloadMusic/download_music.php?serve=css" type="text/css" media="screen"  />'; 
		}
    }
}

//instantiate the class
if (class_exists('DownloadMusic')) {
	$DownloadMusic = new DownloadMusic();
}

?>