<?php
  /*
   * Modified version of force_download from http://www.phpit.net/article/creating-zip-tar-archives-dynamically-php/5/
   * Modification noted in file below.
   */

function force_download ($data, $name, $mimetype='', $filesize=false) {
  // File size not set?
  // Fixed, why use strlen() when you can use filesize()?
  clearstatcache();
  if ($filesize == false OR !is_numeric($filesize)) {
    $filesize = filesize($data);
  }

  // Mimetype not set?
  if (empty($mimetype)) {
    $mimetype = 'application/octet-stream';
  }

  // Make sure there's not anything else left
  //ob_clean_all();

  // Start sending headers
  header("Pragma: public"); // required
  header("Expires: 0");
  header("Cache-Control: must-revalidate, post-check=0, pre-check=0");
  header("Cache-Control: private",false); // required for certain browsers
  header("Content-Transfer-Encoding: binary");
  header("Content-Type: " . $mimetype);
  header("Content-Length: " . $filesize);
  header("Content-Disposition: attachment; filename=\"" . $name . "\";" );

  // Send data

  //doesn't work, for some reason file is only 51 bytes big.
  //echo $data; 

  //from http://www.jeroenwijering.com/?thread=5651#msg25831
  //just a loop to echo the data out to the browser
  $ctx = stream_context_create( array( 'http' => array('timeout'=>1) ) );
  $file = file_get_contents($data,'FILE_BINARY',$ctx,0,$filesize+1);
  print $file;

/*  $fh = fopen($data,"rb");
  rewind($fh, 0);
  while (!feof($fh)) { print(fread($fh, filesize($file)+1)); }
  fclose($fh);
  //die();*/
}

function ob_clean_all () {
  $ob_active = ob_get_length () !== false;
  while($ob_active) {
    ob_end_clean();
    $ob_active = ob_get_length () !== false;
  }

  return true;
}
?>